#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long

ll gcd(ll a, ll b) {
    if (a < b)
        swap(a, b);
    if (b == 0)
        return a;
    return gcd(b, a%b);
}

vector<ll> fib;

ll ask(ll a, ll last) {
    if (a == 1)
        return 1;
    ll ret = 0;
    for (ll i = last; i < 86 && a >= fib[i]; ++i)
        if (a%fib[i] == 0)
            ret += ask(a/fib[i], i);
    return ret;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    unordered_set<ll> infib;
    fib.push_back(2);
    fib.push_back(3);
    infib.insert(2);
    infib.insert(3);
    for (int i = 0; i < 84; ++i) {
        fib.push_back(fib[i] + fib[i + 1]);
        infib.insert(fib[i] + fib[i + 1]);
    }


    ll _, n;
    cin >> _;
    while (_--) {
        cin >> n;
        cout << ask(n, 0) << endl;
    }
}
/*

5
2
7
8
40
64

 */