#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define F first
#define S second

struct st { // ДО позиции максимумов
    vector<ll> pm1, pm2, arr;
    ll size;

    st(vector<ll> &inp) {
        arr = inp;
        ll k = 1;
        while (k < inp.size())
            k *= 2;
        size = k*2;
        pm1.resize(size);
        pm2.resize(size);
        for (int i = 0; i < inp.size(); ++i) {
            pm1[i+k] = i;
            pm2[i+k] = -1;
        }
        for (int i = inp.size(); i < k; ++i)
            pm1[i+k] = pm2[i+k] = -1;

        while (--k) {
            auto p = merge({pm1[k*2], pm2[k*2]}, {pm1[k*2+1], pm2[k*2+1]});
            pm1[k] = p.F;
            pm2[k] = p.S;
        }
    }

    pair<ll, ll> merge(pair<ll, ll> p1, pair<ll, ll> p2) {
        ll k1, k2;
        if (p2.F == -1) {
            k1 = p1.F;
            k2 = p1.S;
        } else if (p2.S == -1) {
            ll a = p1.F;
            ll b = p1.S;
            ll c = p2.F;
            if (arr[a] > arr[c]) {
                k1 = a;
                if (arr[b] > arr[c])
                    k2 = b;
                else
                    k2 = c;
            } else {
                k1 = c;
                k2 = a;
            }
        } else {
            ll a = p1.F;
            ll b = p1.S;
            ll c = p2.F;
            ll d = p2.S;
            if (arr[a] > arr[c]) {
                k1 = a;
                if (arr[b] > arr[c])
                    k2 = b;
                else
                    k2 = c;
            } else {
                k1 = c;
                if (arr[a] > arr[d])
                    k2 = a;
                else
                    k2 = d;
            }
        }
        return {k1, k2};
    }

    ll l, r;
    pair<ll, ll> ans;

    pair<ll, ll> ask(ll _l, ll _r) {
        l = _l, r = _r;
        ans = {-1, -1};
        ask(0, size/2, 1);
        return ans;
    }

    void ask(ll L, ll R, ll now) {
        if (L >= l && R <= r)
            ans = merge({pm1[now], pm2[now]}, ans);
        else if (L >= r || R <= l)
            return;
        else
            ask(L, (R+L)>>1, now<<1), ask((R+L)>>1, R, now*2+1);
    }
};

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    ll n, _;
    cin >> n >> _;
    vector<ll> arr(n);
    for (ll &i : arr)
        cin >> i;

    auto DO = new st(arr);

    ll a, b;
    while (_--) {
        cin >> a >> b;
        if (b == 1) {
            cout << 1 << endl;
            continue;
        }
        a--;
        ll ans = 0;

        if (a >= b-1 && (a == b-1 || arr[a-b] > arr[a])) {
            if (b-1 == 1)
                ans++;
            else {
                auto p = DO->ask(a - b + 1, a);
                if (arr[p.F] < arr[a])
                    ans += b-1;
                else {
                    ans += p.F - (a-b+1);
                    ans += p.S == -1 || p.S > p.F;
                }
            }
        }
        if (a <= n-b && (a == n-b || arr[a+b] > arr[a])) {
            if (b-1 == 1)
                ans++;
            else {
                auto p = DO->ask(a+1, a + b);
                if (arr[p.F] < arr[a])
                    ans += b-1;
                else {
                    ans += a+b-p.F-1;
                    ans += p.S == -1 || p.S < p.F;
                }
            }
        }

        cout << ans << endl;
    }

    return 0;
}
/*
6 4
1 4 6 5 2 3
3 1
2 2
6 3
4 3

5 3
5 2 3 4 1
2 3
4 4
3 2


 */