#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define F first
#define S second

struct st { // ДО позиции максимумов
    vector<ll> pm1, pm2, arr;
    ll size;

    st(vector<ll> &inp) {
        arr = inp;
        ll k = 1;
        while (k < inp.size())
            k *= 2;
        size = k * 2;
        pm1.resize(size);
        pm2.resize(size);
        for (int i = 0; i < inp.size(); ++i) {
            pm1[i + k] = i;
            pm2[i + k] = (ll)arr.size() - 1;
        }
        for (int i = inp.size(); i < k; ++i)
            pm1[i + k] = pm2[i + k] = (ll)arr.size() - 1;

        while (--k) {
            auto p = merge({pm1[k * 2], pm2[k * 2]}, {pm1[k * 2 + 1], pm2[k * 2 + 1]});
            pm1[k] = p.F;
            pm2[k] = p.S;
        }
    }

    pair<ll, ll> merge(pair<ll, ll> p1, pair<ll, ll> p2) {
        ll k1, k2;
        if (arr[p1.F] > arr[p2.F]) {
            k1 = p1.F;
            if (arr[p1.S] > arr[p2.F])
                k2 = p1.S;
            else
                k2 = p2.F;
        } else {
            k1 = p2.F;
            if (arr[p1.F] > arr[p2.S])
                k2 = p1.F;
            else
                k2 = p2.S;
        }
        return {k1, k2};
    }

    ll l, r;
    pair<ll, ll> ans;

    pair<ll, ll> ask(ll _l, ll _r) {
        l = _l, r = _r;
        ans = {(ll)arr.size() - 1, (ll) arr.size()-1};
        ask(0, size / 2, 1);
        return ans;
    }

    void ask(ll L, ll R, ll now) {
        if (L >= l && R <= r)
            ans = merge({pm1[now], pm2[now]}, ans);
        else if (L >= r || R <= l)
            return;
        else
            ask(L, (R + L) >> 1, now << 1), ask((R + L) >> 1, R, now * 2 + 1);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, _;
    cin >> n >> _;
    vector<ll> arr(n);
    for (ll &i: arr)
        cin >> i;
    arr.push_back(LLONG_MIN);

    auto DO = new st(arr);

    ll a, b;
    while (_--) {
        cin >> a >> b;
        if (b == 1) {
            cout << 1 << endl;
            continue;
        }
        a--;
        ll ans = 0;

        if (a >= b - 1 && (a == b - 1 || arr[a - b] > arr[a])) {
            auto p = DO->ask(a - b + 1, a);
            if (p.S == -1)
                p.S = n;

            if (a != b - 1 && arr[p.F] > arr[a-b])
                ans += arr[p.S] < arr[a] || p.S > p.F && arr[p.S] < arr[a-b];
            else if (arr[p.F] < arr[a]){
                ans += b-1;
            } else {
                ans += p.F - (a-b+1);
                ans += arr[p.S] < arr[a] || p.S > p.F && arr[p.S] < arr[a-b];
            }
        }

        if (a <= n - b && (a == n - b || arr[a + b] > arr[a])) {
            auto p = DO->ask(a + 1, a + b);
            if (p.S == -1)
                p.S = n;

            if (a != n - b && arr[p.F] > arr[a+b])
                ans += arr[p.S] < arr[a] || p.S < p.F && arr[p.S] < arr[a+b];
            else if (arr[p.F] < arr[a]){
                ans += b-1;
            } else {
                ans += a+b - p.F-1;
                ans += arr[p.S] < arr[a] || p.S < p.F && arr[p.S] < arr[a+b];
            }
        }

        cout << ans << endl;
    }

    return 0;
}
/*
6 9999
1 4 6 5 2 3


6 9999
1 4 6 5 2 3
1 4

*/