#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define F first
#define S second

ll n, t, root;
vector<pair<ll, ll>> arr;
string ans;
unordered_map<ll, pair<vector<ll>, vector<ll>>> grs;

bool cmp(const ll &a, const ll &b) {
    ld x1 = (arr[a].F - arr[root].F);
    ld y1 = (arr[a].S - arr[root].S);
    ld x2 = (arr[b].F - arr[root].F);
    ld y2 = (arr[b].S - arr[root].S);
    if (x1 >= 0 && x2 < 0)
        return 1;
    else if (x1 < 0 && x2 >= 0)
        return 0;
    else if (x1 == 0 && x2 == 0) {
        if (y1 < 0 && y2 > 0)
            return 1;
        else if (y1 > 0 && y2 < 0)
            return 0;
        else if (y1 > 0 && y2 > 0)
            return y1 <= y2;
        else
            return y1 >= y2;
    } else if (x1 == 0) {
        if (y1 < 0)
            return 1;
        else
            return x2 < 0;
    } else if (x2 == 0) {
        if (y2 < 0)
            return 0;
        else
            return x1 >= 0;
    } else {
        y1 /= x1;
        y2 /= x2;
        return y1 <= y2;
    }
}

vector<vector<pair<ll, ll>>> g;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> t;
    ans.assign(n, 'R');
    arr.resize(n);
    for (auto &p : arr)
        cin >> p.F >> p.S;

    for (int i = 0; i < n; ++i) {
        vector<ll> help, pos(n);
        pos[i] = -1;
        for (int j = 0; j < n; ++j)
            if (i != j)
                help.push_back(j);
        root = i;
        sort(help.begin(), help.end(), cmp);
        for (int j = 0; j < n-1; ++j)
            pos[help[j]] = j;
        grs[i] = {help, pos};

    }


    g.resize(n);
    for (int i = 0; i < n; ++i) {
        g[i].resize(n);
        g[i][i] = {-1, -1};
        for (int j = 0; j < n; ++j)
            if (i != j) {
                arr.emplace_back(arr[j].F + (arr[j].F-arr[i].F), arr[j].S + (arr[j].S-arr[i].F));
                auto p = &grs[j];
                ll l = -1, r = n-1, m;
                while (r-l > 1) {
                    m = (r+l)/2;
                    if (!cmp(n, p->F[m]))
                        l = m;
                    else
                        r = m;
                }
                arr.pop_back();

                g[i][j] = {j, p->F[(r+t-1)%(n-1)]};
            }
    }

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            cout << i+1 << ' ' << j+1 << ": " << g[i][j].F+1 << ' ' << g[i][j].S+1 << '\n';



    /*
     for (char c : ans)
        cout << c;
    */
}
/*
6 4
-1 -1
1 -2
4 -2
2 -4
2 3
-4 -5

 */